#!/usr/bin/env python

__author__ = 'matt.kerr'
__copyright__ = "Copyright 2011, G2, Inc."
__credits__ = ["Matt Kerr"]
__license__ = "TODO"
__version__ = "TODO"
__maintainer__ = 'matt.kerr'
__email__ = "TODO"
__status__ = "Alpha"  

import subprocess
import time
import random
import string

def performCleanup(workingDir=None):
    # remove users from groups
    subprocess.call(["net","localgroup","guests","testuser","/delete"])
    subprocess.call(["net","localgroup","guests","testsub1","/delete"])
    #subprocess.call(["net","localgroup","guests","SCAPValidationGroup1","/delete"])
    subprocess.call(["net","localgroup","SCAPValidationGroup2","SCAPValidationUser1","/delete"])
    subprocess.call(["net","localgroup","SCAPValidationGroup2","SCAPValidationUser2","/delete"])
    subprocess.call(["net","localgroup","SCAPValidationGroup2","SCAPValidationUser3","/delete"])
    # delete groups
    subprocess.call(["net","localgroup","testsub1","/delete"])
    subprocess.call(["net","localgroup","testsub2","/delete"])
    subprocess.call(["net","localgroup","SCAPValidationGroup1","/delete"])
    subprocess.call(["net","localgroup","SCAPValidationGroup2","/delete"])
    # delete users
    subprocess.call(["net","user","testuser","/delete"])
    subprocess.call(["net","user","testuser2","/delete"])
    subprocess.call(["net","user","SCAPValidationUser1","/delete"])
    subprocess.call(["net","user","SCAPValidationUser2","/delete"])
    subprocess.call(["net","user","SCAPValidationUser3","/delete"])
    # remove from guests group
    subprocess.call(["net","localgroup","guests","testuser2","/delete"])
    subprocess.call(["net","localgroup","guests","testsub2","/delete"])
    return

def performGenPassword(workingDir=None):
    chars = string.ascii_letters + string.digits + string.punctuation
    newpasswdgen = ''
    length = 14
    for i in range(length):
        newpasswdgen = ''.join(random.choice(chars) for x in range(length))
    return newpasswdgen

def performConfig(workingDir=None):
    #Cleanup first
    print ("\n----------------------------------")
    print ("Deleting the existing configuration...")
    performCleanup()
    print ("\n----------------------------------")
    print ("Configuring the system...")
    newpass = performGenPassword()
    print ("Generated complex password: ", newpass)
    #Create users
    print ("creating user: 'testuser'")
    subprocess.call(["net","user","testuser",newpass,"/add"])
    print ("creating user: 'testuser2'")
    subprocess.call(["net","user","testuser2",newpass,"/add"])
    print ("creating user: 'SCAPValidationUser1'")
    subprocess.call(["net","user","SCAPValidationUser1",newpass,"/add"])
    print ("creating user: 'SCAPValidationUser2'")
    subprocess.call(["net","user","SCAPValidationUser2",newpass,"/add"])
    print ("creating user: 'SCAPValidationUser3'")
    subprocess.call(["net","user","SCAPValidationUser3",newpass,"/add"])

    #Create groups
    print ("creating group: 'testsub1'")
    subprocess.call(["net","localgroup","testsub1","/add"])
    print ("creating group: 'testsub2'")
    subprocess.call(["net","localgroup","testsub2","/add"])
    print ("creating group: 'SCAPValidationGroup1'")
    subprocess.call(["net","localgroup","SCAPValidationGroup1","/add"])
    print ("creating group: 'SCAPValidationGroup2'")
    subprocess.call(["net","localgroup","SCAPValidationGroup2","/add"])

    #add users to groups
    subprocess.call(["net","localgroup","guests","testuser","/add"])
    subprocess.call(["net","localgroup","guests","testsub1","/add"])
    #subprocess.call(["net","localgroup","guests","SCAPValidationGroup1","/add"])
    subprocess.call(["net","localgroup","SCAPValidationGroup2","SCAPValidationUser1","/add"])
    subprocess.call(["net","localgroup","SCAPValidationGroup2","SCAPValidationUser2","/add"])
    subprocess.call(["net","localgroup","SCAPValidationGroup2","SCAPValidationUser3","/add"])
    print("I'm done.")
	
	
if __name__=="__main__":
    performConfig()