#!/usr/bin/env python

__author__ = 'dragos.prisaca'
__copyright__ = "Copyright 2017, G2, Inc."
__credits__ = ["Dragos Prisaca"]
__license__ = "TODO"
__version__ = "TODO"
__maintainer__ = 'dragos.prisaca'
__email__ = "TODO"
__status__ = "Alpha"

import os
import sys
import pythoncom
from win32com.shell import shell, shellcon
import shutil
import time
import datetime
import win32file

def performConfig(workingDir=None):
    file1 = r'\scap_validation_content\win_file\e\1.txt'
    file2 = r'\scap_validation_content\win_file\e\2.txt'
    file3 = r'\scapVal\File-Test-Level2\Level3-Folder010\Level3-File010.txt'
    file4 = r'\scapVal\File-Test-Level2\Level3-Folder010\Level4-Folder011\Level5-Folder012\Level5-File0121.txt'
    file5 = r'\scapVal\File-Test-Level2\Level3-Folder010\Level4-Folder011\Level5-Folder012\Level5-File0122.log'
    file6 = r'\scapVal-Sym\File-Test-Level2-SymLinked\Level3-SymLinked-Folder010\Level3-File.txt'
    file7 = r'\scapVal-Sym\File-Test-Level2-SymLinked\Level3-SymLinked-Folder010\Level4-Folder\Level4-File.txt'
    file8 = r'this_is_a_shortcut.lnk'
    file9 = r'\scapVal-Sym\File-Test-Level2-SymLinked\File-Test-Sym-Level2.txt'
    file10 = r'c:\File-Test-Level0.txt'

    # check for existence of files and create if necessary
    if not os.path.exists(r'\scap_validation_content'):
        os.mkdir(r'\scap_validation_content')
    if not os.path.exists(r'\scap_validation_content\win_file'):
        os.mkdir(r'\scap_validation_content\win_file')
    if not os.path.exists(r'\scap_validation_content\win_file\e'):
        os.mkdir(r'\scap_validation_content\win_file\e')
    if not os.path.exists(file1):
        open(file1, "w").close()
    if not os.path.exists(file2):
        open(file2, "w").close()

    # copy the skeleton.exe file to c:\scap_validation_content\win_file
    if workingDir is not None:
        srcFile = os.path.join(workingDir, 'Skeleton.exe')
    else:
        srcFile = r'Skeleton.exe'
    dstFile = os.path.join(r'\scap_validation_content\win_file\e',r'Skeleton.exe')
    shutil.copy(srcFile, dstFile)
    t = makeTime(year=2011, day=29, month=6, hour=11, min=59, sec=0)
    os.utime(dstFile, (t,t))
    
    # Configuration for @behaviour attribute
    if not os.path.exists(r'\scapVal'):
        os.mkdir(r'\scapVal')
    if not os.path.exists(r'\scapVal\File-Test-Level2'):
        os.mkdir(r'\scapVal\File-Test-Level2')
    if not os.path.exists(r'\scapVal\File-Test-Level2\Level3-Folder010'):
        os.mkdir(r'\scapVal\File-Test-Level2\Level3-Folder010')
    if not os.path.exists(r'\scapVal\File-Test-Level2\Level3-Folder020'):
        os.mkdir(r'\scapVal\File-Test-Level2\Level3-Folder020')
    if not os.path.exists(r'\scapVal\File-Test-Level2\Level3-Folder030'):
        os.mkdir(r'\scapVal\File-Test-Level2\Level3-Folder030')
    if not os.path.exists(r'\scapVal\File-Test-Level2\Level3-Folder040'):
        os.mkdir(r'\scapVal\File-Test-Level2\Level3-Folder040')
    if not os.path.exists(r'\scapVal\File-Test-Level2\Level3-Folder050'):
        os.mkdir(r'\scapVal\File-Test-Level2\Level3-Folder050')
    if not os.path.exists(r'\scapVal\File-Test-Level2\Level3-Folder010\Level4-Folder011'):
        os.mkdir(r'\scapVal\File-Test-Level2\Level3-Folder010\Level4-Folder011')
    if not os.path.exists(r'\scapVal\File-Test-Level2\Level3-Folder010\Level4-Folder011\Level5-Folder012'):
        os.mkdir(r'\scapVal\File-Test-Level2\Level3-Folder010\Level4-Folder011\Level5-Folder012')
    if not os.path.exists(file3):
        f = open(file3, 'w')
        f.write('This is a Level3-File scap validation test file.\n')
        f.close()
    if not os.path.exists(file4):
        f = open(file4, 'w')
        f.write('This is a Level5-File 0121 test file for the scap validation program.\n')
        f.close()
    if not os.path.exists(file5):
        f = open(file5, 'w')
        f.write('This is a Level5-File 0122 test file for the scap validation program.\n')
        f.close()
    if not os.path.exists(r'\scapVal-Sym'):
        os.mkdir(r'\scapVal-Sym')
        os.mkdir(r'\scapVal-Sym\File-Test-Level2-SymLinked')
        os.mkdir(r'\scapVal-Sym\File-Test-Level2-SymLinked\Level3-SymLinked-Folder010')
        os.mkdir(r'\scapVal-Sym\File-Test-Level2-SymLinked\Level3-SymLinked-Folder010\Level4-Folder')
    if not os.path.exists(file6):
        f = open(file6, 'w')
        f.write('This is a Level3-File test file for the scap validation program.\n')
        f.close()
    if not os.path.exists(file7):
        f = open(file7, 'w')
        f.write('This is a Level4-File test file for the scap validation program.\n')
        f.close()
        
    if not os.path.exists(file8):
        MyShortcut = pythoncom.CoCreateInstance (
          shell.CLSID_ShellLink,
          None,
          pythoncom.CLSCTX_INPROC_SERVER,
          shell.IID_IShellLink
        )
        MyShortcut.SetPath ('C:\scapVal-Sym\File-Test-Level2-SymLinked')
        MyShortcut.SetDescription ("SCAP Validation Program")
        MyFile8 = MyShortcut.QueryInterface (pythoncom.IID_IPersistFile)
        MyFile8.Save (os.path.join ('C:\scapVal\File-Test-Level2\Level3-Folder040', file8), 0)
        
    if not os.path.exists(file9):
        f = open(file9, 'w')
        f.write('This is a Level2-File test file for the scap validation program.\n')
        f.close()
    if not os.path.exists(file10):
        f = open(file10, 'w')
        f.write('This is a Level0-File test file for the scap validation program.\n')
        f.close()
    return

def makeTime(year = None, day=None, month=None, hour=None, min=None, sec=None):
    d = datetime.datetime(year, month, day, hour, min, sec, 0, None)
    t = time.mktime(d.utctimetuple())
    return t

if __name__ == "__main__":
    performConfig()